Avira.MarketingResearch.Web/Controllers/MarketController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using Avira.MarketingResearch.LogService;
using Avira.MarketingResearch.Model.ViewModels;
using Avira.MarketingResearch.Model.ViewModels.Masters;
using Avira.MarketingResearch.Web.CustomFilter;
using Avira.MarketingResearch.Web.Models;
using Avira.MarketingResearch.WebApiService;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;

namespace Avira.MarketingResearch.Web.Controllers
{
    [NoCache]
    [Authorization]
    public class MarketController : BaseController
    {
        public readonly IServiceRepository _serviceRepository;
        private ILoggerManager _logger;
        public MarketController(IServiceRepository serviceRepository, ILoggerManager logger)
        {
            _serviceRepository = serviceRepository;
            _logger = logger;
        }

        public ActionResult Index()
        {
            return View();
        }

        public ActionResult LoadData(MarketViewModel market)
        {
            var draw = Request.Form["draw"].FirstOrDefault();
            List<MarketViewModel> data = null;
            int totalRecords = 0;
            try
            {
                var start = Request.Form["start"].FirstOrDefault();
                var length = Request.Form["length"].FirstOrDefault();
                string search = Request.Form["search[value]"];

                var sortColumn = Request.Form["columns[" + Request.Form["order[0][column]"].FirstOrDefault() + "][name]"].FirstOrDefault();
                var sortColumnDir = Request.Form["order[0][dir]"].FirstOrDefault();
                var SortDirection = -1;
                if (sortColumnDir == "asc")
                {
                    SortDirection = 1;
                }
                else
                {
                    SortDirection = -1;
                }

                int skip = start != null ? Convert.ToInt32(start) : 0;
                int pageSize = length.ToString() != null ? Convert.ToInt32(length) : 0;
                int PageStart = start.ToString() != null ? Convert.ToInt32(start) : 0;
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();

                HttpResponseMessage response = _serviceRepository.GetResponse(contollerName, PageStart, pageSize, SortDirection, sortColumn, search);
                response.EnsureSuccessStatusCode();
                List<MarketViewModel> markets = response.Content.ReadAsAsync<List<MarketViewModel>>().Result;
                ViewBag.Title = "All Markets";
                data = markets;
                
                foreach (var item in markets)
                {
                    totalRecords = item.TotalItems;
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            return Json(new { draw = draw, recordsFiltered = totalRecords, recordsTotal = totalRecords, data = data });

        }

        public ActionResult Create()
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.GetAllParentResponse(contollerName);
                List<MarketViewModel> marketList = response.Content.ReadAsAsync<List<MarketViewModel>>().Result;
                ViewBag.MarketList = new SelectList(marketList, "Id", "MarketName");
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            return View();
        }

        [HttpPost]
        public IActionResult Create(MarketInsertDbViewModel market)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.PostResponse(contollerName, market);
                response.EnsureSuccessStatusCode();
                ViewData viewModel = response.Content.ReadAsAsync<ViewData>().Result;
                if (viewModel != null)
                {
                    ViewBag.Message = viewModel.Message;
                }
            }
            catch(Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            return RedirectToAction("Index");
        }

        [HttpGet]
        public IActionResult Edit(string id)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.GetByIdResponse(contollerName, id);
                response.EnsureSuccessStatusCode();
                HttpResponseMessage response1 = _serviceRepository.GetAllParentResponse(contollerName);
                MarketUpdateDbViewModel market = response.Content.ReadAsAsync<MarketUpdateDbViewModel>().Result;
                response1.EnsureSuccessStatusCode();
                List<MarketViewModel> marketList = response1.Content.ReadAsAsync<List<MarketViewModel>>().Result;
                ViewBag.MarketList = new SelectList(marketList, "Id", "MarketName", market.ParentId);
                return View(market);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
                ErrorViewModel err = new ErrorViewModel { RequestId = "1234" };
                //Log the exception 
                return View("Error", err);
            }
        }

        [HttpPost]
        public IActionResult Edit(MarketUpdateDbViewModel market)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.PutResponse(contollerName, market);
                response.EnsureSuccessStatusCode();
                ViewData viewModel = response.Content.ReadAsAsync<ViewData>().Result;
                if (viewModel != null)
                {
                    ViewBag.Message = viewModel.Message;
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            return RedirectToAction("Index");
        }

        [HttpGet]
        public IActionResult Delete(string id)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.GetByIdResponse(contollerName, id);
                response.EnsureSuccessStatusCode();
                MarketUpdateDbViewModel market = response.Content.ReadAsAsync<MarketUpdateDbViewModel>().Result;
                if (market.ParentId.HasValue)
                {
                    HttpResponseMessage response1 = _serviceRepository.GetByIdResponse(contollerName, market.ParentId.ToString());
                    response1.EnsureSuccessStatusCode();
                    MarketViewModel parentMarket = response1.Content.ReadAsAsync<MarketViewModel>().Result;
                    ViewBag.ParentName = parentMarket.MarketName;
                }
                else
                {
                    ViewBag.ParentName = String.Empty;
                }
                return View(market);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
                ErrorViewModel err = new ErrorViewModel { RequestId = "1234" };
                //Log the exception 
                return View("Error", err);
            }
        }

        [HttpPost]
        public IActionResult Delete(MarketUpdateDbViewModel market)
        {
            try
            {
                var contollerName = this.ControllerContext.RouteData.Values["controller"].ToString();
                HttpResponseMessage response = _serviceRepository.DeleteResponse(contollerName, market);
                response.EnsureSuccessStatusCode();
                ViewData viewModel = response.Content.ReadAsAsync<ViewData>().Result;
                if (viewModel != null)
                {
                    ViewBag.Message = viewModel.Message;
                }
            }
            catch (Exception ex)
            {
                _logger.LogError(ex.Message);
            }
            return RedirectToAction("Index");
        }
    }
}

Avira.MarketingResearch.Web/Views/Market/Create.cshtml
@model Avira.MarketingResearch.Model.ViewModels.Masters.MarketInsertDbViewModel

@{
    ViewBag.Title = "Add Market";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<script src="~/ckeditor/ckeditor.js"></script>
<div id="content" class="content">
    <h2>Create Market</h2>
    @if (ViewBag.Message != null)
    {
        <div>
            @ViewBag.Message
        </div>
    }
    <div class="section-container section-with-top-border">
        @using (Html.BeginForm("Create", "Market", FormMethod.Post))
        {
            @Html.AntiForgeryToken()

            <div class="form-horizontal">

                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.Id)

                <div class="form-group">
                    @Html.LabelFor(model => model.MarketName, "Market Name", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.EditorFor(model => model.MarketName, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.MarketName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.TextAreaFor(model => model.Description, htmlAttributes: new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
                        <script>
                            CKEDITOR.replace('Description', {
                                height: 40,
                                // Define the toolbar groups as it is a more accessible solution.
                                toolbarGroups: [{
                                    "name": "basicstyles",
                                    "groups": ["basicstyles"]
                                },
                                {
                                    "name": "links",
                                    "groups": ["links"]
                                },
                                {
                                    "name": "paragraph",
                                    "groups": ["list", "blocks"]
                                },
                                {
                                    "name": "document",
                                    "groups": ["mode"]
                                },
                                {
                                    "name": "insert",
                                    "groups": ["insert"]
                                },
                                {
                                    "name": "styles",
                                    "groups": ["styles"]
                                },
                                {
                                    "name": "about",
                                    "groups": ["about"]
                                }
                                ],
                                // Remove the redundant buttons from toolbar groups defined above.
                                removeButtons: 'Underline,Strike,Subscript,Superscript,Anchor,Styles,Specialchar'
                            });
                        </script>
                    </div>
                </div>
                <div class="form-group">
                    @Html.Label("ParentMarket", "Parent Market", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-5">
                        @Html.DropDownListFor(Model => Model.ParentId, (SelectList)(ViewBag.MarketList), "Please select", htmlAttributes: new { @class = "form-control" })
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-md-offset-5 p-l-15">
                        <input type="submit" value="Save" class="btn btn-rounded btn-grey m-b-5 width-100" />
                        <a href="~/Market/Index" class="btn btn-rounded btn-inverse m-b-5 width-100">Back to List </a>
                    </div>
                </div>
            </div>

        }


    </div>
</div>

Avira.MarketingResearch.Web/Views/Market/Delete.cshtml
@model Avira.MarketingResearch.Model.ViewModels.Masters.MarketUpdateDbViewModel

@{
    ViewBag.Title = "Delete Market";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<div id="content" class="content">
    <h2>Delete Market</h2>
    @if (ViewBag.Message != null)
    {
        <div>
            @ViewBag.Message
        </div>
    }
    <div class="section-container section-with-top-border">
        @using (Html.BeginForm("Delete", "Market", FormMethod.Post))
        {
            @Html.AntiForgeryToken()

            <div class="form-horizontal">

                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.Id)

                <div class="form-group">
                    Are you sure want to delete this Market?
                </div>

                <div class="form-group">
                    @Html.LabelFor(model => model.MarketName, "Market Name", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-5">
                        @Html.EditorFor(model => model.MarketName, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })

                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-5">
                        @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })

                    </div>
                </div>

                <div class="form-group">
                    @Html.Label("ParentMarket", "Parent Market", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-5">
                        @Html.Label(ViewBag.ParentName, ViewBag.ParentName, htmlAttributes: new { @class = "form-control", @readonly = "readonly" })
                    </div>


                </div>

                <div class="form-group">
                    <div class="col-md-2"></div>
                    <div class="col-md-offset-5 p-l-15">
                        <input type="submit" value="Delete" class="btn btn-rounded btn-grey m-b-5 width-100" />
                        <a href="~/Market/Index" class="btn btn-rounded btn-inverse m-b-5 width-100">Back to List </a>
                    </div>
                </div>
            </div>

        }
        <div id="footer" class="footer">
            <span class="pull-right">
                <a href="javascript:;" class="btn-scroll-to-top" data-click="scroll-top">
                    <i class="fa fa-arrow-up"></i> <span class="hidden-xs">Back to Top</span>
                </a>
            </span>
            &copy; 2018 <b>Source Admin</b> All Right Reserved
        </div>
    </div>
</div>

Avira.MarketingResearch.Web/Views/Market/Edit.cshtml
@model Avira.MarketingResearch.Model.ViewModels.Masters.MarketUpdateDbViewModel

@{
    ViewBag.Title = "Edit Market";
}

<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<script src="~/ckeditor/ckeditor.js"></script>
<div id="content" class="content">
    <h2>
        Edit Market
    </h2>
    @if (ViewBag.Message != null)
    {
        <div>
            @ViewBag.Message
        </div>
    }
    <div class="section-container section-with-top-border">

        @using (Html.BeginForm("Edit", "Market", FormMethod.Post))
        {
            @Html.AntiForgeryToken()

            <div class="form-horizontal">


                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.Id)

                <div class="form-group">
                    @Html.LabelFor(model => model.MarketName, "Market Name", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.EditorFor(model => model.MarketName, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.MarketName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group">
                    @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-7">
                        @Html.TextAreaFor(model => model.Description, htmlAttributes: new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
                        <script>
                            CKEDITOR.replace('Description', {
                                height: 40,
                                // Define the toolbar groups as it is a more accessible solution.
                                toolbarGroups: [{
                                    "name": "basicstyles",
                                    "groups": ["basicstyles"]
                                },
                                {
                                    "name": "links",
                                    "groups": ["links"]
                                },
                                {
                                    "name": "paragraph",
                                    "groups": ["list", "blocks"]
                                },
                                {
                                    "name": "document",
                                    "groups": ["mode"]
                                },
                                {
                                    "name": "insert",
                                    "groups": ["insert"]
                                },
                                {
                                    "name": "styles",
                                    "groups": ["styles"]
                                },
                                {
                                    "name": "about",
                                    "groups": ["about"]
                                }
                                ],
                                // Remove the redundant buttons from toolbar groups defined above.
                                removeButtons: 'Underline,Strike,Subscript,Superscript,Anchor,Styles,Specialchar'
                            });
                        </script>
                    </div>


                </div>

                <div class="form-group">
                    @Html.Label("ParentMarket", "Parent Market", htmlAttributes: new { @class = "col-md-2" })
                    <div class="col-md-5">
                        @Html.DropDownListFor(Model => Model.ParentId, (SelectList)(ViewBag.MarketList), "Please select", htmlAttributes: new { @class = "form-control" })
                    </div>


                </div>

                <div class="form-group">
                    <div class="col-md-2"></div>
                    <div class="col-md-offset-5">
                        <input type="submit" value="Save" class="btn btn-rounded btn-grey m-b-5 width-100" />
                        <a href="~/Market/Index" class="btn btn-rounded btn-inverse m-b-5 width-100">Back to List </a>
                    </div>
                </div>
            </div>

        }
    </div> <div id="footer" class="footer">
        <span class="pull-right">
            <a href="javascript:;" class="btn-scroll-to-top" data-click="scroll-top">
                <i class="fa fa-arrow-up"></i> <span class="hidden-xs">Back to Top</span>
            </a>
        </span>
        &copy; 2018 <b>Source Admin</b> All Right Reserved
    </div>
</div>

Avira.MarketingResearch.Web/Views/Market/Index.cshtml
@{
    ViewBag.Title = "All Market";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<link href="~/assets/css/avira-custom.css" rel="stylesheet" />
<script src="~/assets/plugins/jquery/jquery-3.3.1.min.js"></script>
<script src="~/assets/js/page-table-manage.demo.min.js"></script>
<div id="content" class="content">
    <div class="section-with-top-border">
        <div class="row">
            <div class="col-md-4">
                <h4> Market </h4>
            </div>
            <div class="col-md-8 text-right" style="padding-right:35px" ;>
                <a href="~/Market/Create" class="btn btn-sm btn-inverse width-200">Add New Market</a>
            </div>

        </div>
            <!-- begin panel -->
            <div class="panel pagination-inverse m-b-0 clearfix">

                <table id="data-table" data-order='[[0,"asc"]]' class="table table-bordered table-hover">
                    <thead>
                        <tr class="inverse">
                            <th>Market Name</th>
                            <th>Description</th>
                            <th>Parent Market</th>
                            <th style="pointer-events:none!important" data-sorting="disabled">Actions</th>
                        </tr>
                    </thead>

                </table>
            </div>
            <!-- end panel -->
        </div>

        <div id="footer" class="footer">
            <span class="pull-right">
                <a href="javascript:;" class="btn-scroll-to-top" data-click="scroll-top">
                    <i class="fa fa-arrow-up"></i> <span class="hidden-xs">Back to Top</span>
                </a>
            </span>
            &copy; 2018 <b>Source Admin</b> All Right Reserved
        </div>
        <!-- end #footer -->
    </div>
    <script>
        $(document).ready(function () {
            $("#data-table").DataTable({
                "processing": true, 
                "serverSide": true, 
                "filter": true, 
                "orderMulti": false, 
                "ajax": {
                    "url": "/Market/LoadData",
                    "type": "POST",
                    "datatype": "json",
                },

                "columns": [
                    { "data": "marketName", "name": "rawMaterialName" },
                    { "data": "description", "name": "description" },
                    { "data": "parentMarketName", "name": "parentMarketName" },
                    {
                        render: function (data, type, full, meta) { return '<a class="btn btn-default btn-xs btn-rounded p-l-10 p-r-10" title="Edit" href="/Market/Edit/' + full.id + '"><i class="fas fa-edit"></i></a> <a class="btn btn-default btn-xs btn-rounded p-l-10 p-r-10" title="Delete" href="/Market/Delete/' + full.id + '"><i class="far fa-trash-alt"></i></a>'; }
                    },
                ]
            });
        });
    </script>